### R code from vignette source 'lfehow.Rnw'
### Encoding: ISO8859-1

###################################################
### code chunk number 1: lfehow.Rnw:53-54 (eval = FALSE)
###################################################
## Y ~ X1 + X2 + ... + Xk + D1 + D2 + ... + De


###################################################
### code chunk number 2: lfehow.Rnw:190-191 (eval = FALSE)
###################################################
## felm(Y ~ X1 + X2 + ... + Xk | D1 + D2 + ... + De)


###################################################
### code chunk number 3: lfehow.Rnw:295-296 (eval = FALSE)
###################################################
## Y ~ X1 + X2 | X3:D1 + D2 + D3


###################################################
### code chunk number 4: lfehow.Rnw:322-326
###################################################
set.seed(41)
x <- rnorm(500)
x2 <- rnorm(length(x))
x3 <- rnorm(length(x))


###################################################
### code chunk number 5: lfehow.Rnw:331-337
###################################################
f1 <- factor(sample(7,length(x),replace=TRUE))
f2 <- factor(sample(4,length(x),replace=TRUE))
f3 <- factor(sample(3,length(x),replace=TRUE))
eff1 <- rnorm(nlevels(f1))
eff2 <- rexp(nlevels(f2))
eff3 <- runif(nlevels(f3))


###################################################
### code chunk number 6: lfehow.Rnw:341-342
###################################################
 y <- x + 0.5*x2 + 0.25*x3 + eff1[f1] + eff2[f2] + eff3[f3] + rnorm(length(x))


###################################################
### code chunk number 7: lfehow.Rnw:346-354
###################################################
demean <- function(v,fl) {
  Pv <- v; oldv <- v-1
  while(sqrt(sum((Pv-oldv)**2)) >= 1e-7) {
    oldv <- Pv
    for(f in fl) Pv <- Pv - ave(Pv,f)
  }
 Pv
}


###################################################
### code chunk number 8: lfehow.Rnw:357-362
###################################################
 fl <- list(f1,f2,f3)
 Py <- demean(y,fl)
 Px <- demean(x,fl)
 Px2 <- demean(x2,fl)
 Px3 <- demean(x3,fl)


###################################################
### code chunk number 9: lfehow.Rnw:365-366
###################################################
summary(lm(Py ~ Px + Px2 + Px3 - 1))


###################################################
### code chunk number 10: lfehow.Rnw:374-376
###################################################
  cores <- as.integer(Sys.getenv('SG_RUN'))
  if(is.na(cores)) options(lfe.threads=1)


###################################################
### code chunk number 11: lfehow.Rnw:378-380
###################################################
 library(lfe, quietly=TRUE)
 summary(est <- felm(y ~ x + x2 + x3 | f1+f2+f3))


###################################################
### code chunk number 12: lfehow.Rnw:389-403
###################################################
ef <- function(v,addnames) {
  r1 <- v[[1]]
  r2 <- v[[8]]
  r3 <- v[[12]]
  result <- c(r1+r2+r3,v[2:7]-r1,v[9:11]-r2,v[13:14]-r3)
  if(addnames) names(result) <- c('(Intercept)',
                             paste('f1',2:7,sep='.'),
                             paste('f2',2:4,sep='.'),
                             paste('f3',2:3,sep='.'))
  result
}
# verify that it's estimable
is.estimable(ef,est$fe)
getfe(est, ef=ef, se=TRUE, bN=10000)


###################################################
### code chunk number 13: lfehow.Rnw:407-408
###################################################
summary(lm(y ~ x + x2 + x3 + f1 + f2 + f3))


