### R code from vignette source 'speed.Rnw'
### Encoding: ISO8859-1

###################################################
### code chunk number 1: speed.Rnw:51-53
###################################################
  cores <- as.integer(Sys.getenv('SG_RUN'))
  if(is.na(cores)) options(lfe.threads=1)


###################################################
### code chunk number 2: speed.Rnw:55-61
###################################################
library(lfe)
set.seed(42)
x <- rnorm(100000)
f1 <- sample(10000,length(x),replace=TRUE)
f2 <- sample(10000,length(x),replace=TRUE)
y <- x + cos(f1) + log(f2+1) + rnorm(length(x), sd=0.5)


###################################################
### code chunk number 3: speed.Rnw:64-65
###################################################
system.time(est <- felm(y ~ x | f1 + f2))


###################################################
### code chunk number 4: speed.Rnw:68-69
###################################################
system.time(alpha <- getfe(est))


###################################################
### code chunk number 5: speed.Rnw:75-79
###################################################
f2 <- sample(300,length(x),replace=TRUE)
y <- x + cos(f1) + log(f2+1) + rnorm(length(x), sd=0.5)
system.time(est <- felm(y ~ x | f1 + f2))
system.time(alpha <- getfe(est))


###################################################
### code chunk number 6: speed.Rnw:93-97
###################################################
f2 <- (f1 + sample(10,length(x),replace=TRUE)) %% 300
y <- x + cos(f1) + log(f2+1) + rnorm(length(x), sd=0.5)
system.time(est <- felm(y ~ x | f1 + f2))
system.time(alpha <- getfe(est))


###################################################
### code chunk number 7: speed.Rnw:105-107
###################################################
system.time(est <- felm(y ~ x + factor(f2) | f1))
system.time(alpha <- getfe(est))


###################################################
### code chunk number 8: speed.Rnw:118-123
###################################################
f2 <- (f1 + sample(10,length(x),replace=TRUE)^3) %% 300
y <- x + cos(f1) + log(f2+1) + rnorm(length(x), sd=0.5)
system.time(est <- felm(y ~ x | f1 + f2))
system.time(alpha <- getfe(est))
nlevels(est[['cfactor']])


###################################################
### code chunk number 9: speed.Rnw:142-153
###################################################
library(igraph)
mkgraph <- function(f1,f2)
  graph.edgelist(cbind(paste('f1',f1),paste('f2',f2)), directed=FALSE)

appxdiam <- function(g) max(shortest.paths(g,sample(V(g),10),sample(V(g),10)))
f2 <- sample(10000,length(x),replace=TRUE)
appxdiam(mkgraph(f1,f2))
f2 <- (f1 + sample(5,length(x),replace=TRUE)^3) %% 300
appxdiam(mkgraph(f1,f2))
f2 <- (f1 + sample(5,length(x),replace=TRUE)) %% 300
appxdiam(mkgraph(f1,f2))


